import 'package:dio/dio.dart';
import 'package:logger/logger.dart';

class LogsInterceptors extends InterceptorsWrapper {
  @override
  onRequest(RequestOptions options) async {
//    if (Config.DEBUG) {

    var logger = Logger();
    String curl = "curl -L ";
    String method = options.method;
    String url = options.baseUrl + options.path;
    String query = Transformer.urlEncodeMap(options.queryParameters);

    if (method.toLowerCase() == "get") {
      if (query.isNotEmpty) {
        url += (url.contains("?") ? "&" : "?") + query;
      }

      logger.d(curl + method + " " + "'" + url + "'");
    } else {
      //dio 接口抓包params有问题，这里用data的
      if (query.isEmpty) {
        query = Transformer.urlEncodeMap(options.data);
      }
      String header =
          " -H " + "\"Content-Type:application/x-www-form-urlencoded\" -d ";
      header += "'" + query + "'";
      logger.d(curl + method + " " + header + " " + "\"" + url + "\"");
    }
//
//    }
    return options;
  }

  @override
  onResponse(Response response) async {
    var logger = Logger();

//    if (Config.DEBUG) {
    if (response != null) {
      logger.d('返回参数: ' + response.toString());
    }
//    }
    return response; // continue
  }

  @override
  onError(DioError err) async {
    var logger = Logger();

//    if (Config.DEBUG) {
    logger.d('请求异常: ' + err.toString());
    logger.d('请求异常信息: ' + err.response?.toString() ?? "");
//    }
    return err;
  }
}
